<template>
  <InputContainer :label="$t('setting.pickWebsite')">
    <div class="input-card selector">
      <div class="websites">
        <div
          v-for="(website, i) in websites"
          :key="website.name"
          class="website-row"
          @click="toggle(i, website)"
        >
          <WebsiteIcon :website="website.name" class="website-icon" />
          <div class="website-text">{{ website.label }}</div>
          <q-checkbox
            :model-value="website.active"
            @update:model-value="toggle(i, website)"
            color="purple-highlight"
          />
          <div v-if="isTwitter(website) && website.active" class="subtext">
            Note: our tools only analyze tweets from verified Twitter accounts.
          </div>
        </div>
      </div>
    </div>
  </InputContainer>
</template>

<script>
import { createNamespacedHelpers } from 'vuex'
import InputContainer from './InputContainer'
import WebsiteIcon from '@/components/WebsiteIcon'
const { TWITTER } = require('@/constants/sites')

const { mapGetters, mapMutations } = createNamespacedHelpers('searchSettings')

export default {
  components: {
    InputContainer,
    WebsiteIcon
  },
  computed: {
    ...mapGetters(['websites']),
  },
  methods: {
    ...mapMutations(['setWebsiteActive']),
    toggle (i, website) {
      this.setWebsiteActive({ i, val: !website.active })
    },
    isTwitter (website) {
      return website.name === TWITTER
    }
  }
}
</script>

<style scoped lang="scss">
.selector {
  color: var(--color-dark-text);
}

.websites {
  width: 100%;
}

.website-row {
  width: 100%;
  display: grid;
  grid-template-columns: auto 1fr auto;
  justify-items: start;
  align-items: center;
  text-align: start;

  cursor: pointer;
  user-select: none;
  padding: var(--spacing-0) 0;

  .subtext {
    grid-column: 2 / 3;

    color: var(--color-light-text);
    line-height: 1.5;
    padding-bottom: 6px;
  }
}

.website-row + .website-row {
  border-top: solid 1px var(--color-dividers);
}

.website-icon {
  margin: 0 var(--spacing-2);
}
</style>
